#!/usr/bin/env ruby

require "tk"

module TkGrid
  def slaves(master, args=None)
    list(tk_call('grid', 'slaves', master, *hash_kv(args)))
  end
  module_function :slaves
end

class TkWindow
  def grid_slaves(args=None)
    list(tk_call('grid', 'slaves', epath, *hash_kv(args)))
  end
end

TkLabel.new {
  width 10
  height 5
  background 'gray'
  text '(0,0)'
  grid('column' => 0, 'row' => 0)
}

TkLabel.new {
  width 10
  height 5
  background 'white'
  text '(1,0)'
  grid('column' => 0, 'row' => 1)
}

TkLabel.new {
  width 10
  height 5
  background 'maroon'
  text '(1,0)'
  grid('column' => 1, 'row' => 0)
}

TkLabel.new {
  width 10
  height 5
  background 'red'
  text '(1,1)'
  grid('column' => 1, 'row' => 1)
}

print TkGrid.slaves(Tk.root), "\n"
print TkGrid.slaves(Tk.root, 'column' => 0), "\n"
print TkGrid.slaves(Tk.root, 'column' => 1), "\n"
print TkGrid.slaves(Tk.root, 'row' => 0), "\n"
print TkGrid.slaves(Tk.root, 'row' => 1), "\n"

print Tk.root.grid_slaves, "\n"
print Tk.root.grid_slaves('column' => 0), "\n"
print Tk.root.grid_slaves('column' => 1), "\n"
print Tk.root.grid_slaves('row' => 0), "\n"
print Tk.root.grid_slaves('row' => 1), "\n"

Tk.mainloop
